/*Copyright: Tim vor der Brck 1999

This software is released under the GNU General Public License Version 2.
It may be redistributed as long this copyright remark is not
removed or modified.
*/
#include "counter.h"


CCounter::CCounter
(int x,int y,CIcon* picon,int value,CPlayfield* playfield):
m_x(x),m_y(y),m_picon(picon),m_value(value),m_playfield(playfield)
{
	
	//evtl. alten Spielstein lschen
	CCounter* ss=m_playfield->getcontents(x,y);
	if (ss!=NULL) delete ss;

	//neuen Spielstein aufs Brett setzen
	m_playfield->setcontents(m_x,m_y,this);
	draw();
}

CCounter::~CCounter()
{
	// Spielstein vom Spielplan entfernen
	if (m_playfield->getcontents(m_x,m_y)==this)
		m_playfield->setcontents(m_x,m_y,NULL);
	m_playfield->removeicon(m_x,m_y,m_picon);
}

void CCounter::smove(int newx,int newy,bool remove)
/* remove gibt an, ob sourcefeld geloescht werden soll*/
{
	//evt. alten Spielstein schlagen
	CCounter* ss=m_playfield->getcontents(newx,newy);
	if (ss!=NULL) delete ss;

	//Spielstein von alter Position entfernen
	m_playfield->setcontents(m_x,m_y,NULL);
	if (remove) m_playfield->removeicon(m_x,m_y,m_picon);

	//Spielstein auf neue Position setzen
	m_playfield->setcontents(newx,newy,this);
	m_x=newx;
	m_y=newy;
	draw();
	
}

void CCounter::draw()
{
	m_playfield->drawicon(m_x,m_y,m_picon);
}

CIcon* CCounter::geticon()
{
	return m_picon;
}

int CCounter::getvalue()
{
        return m_value;
}

CCounter* CCounter::clone(int x,int y) //Erzeugt eine Kopie auf angeg.Position
{
	//Position muss sich von Spielsteinpos. unterscheiden
	if (x==m_x && y==m_y) return NULL;

	CCounter* ss=new CCounter(x,y,m_picon,m_value,m_playfield);
	return ss;
}

void CCounter::transform(CIcon* pnewicon,int newvalue)
{
	//Feld neu zeichnen
	m_playfield->removeicon(m_x,m_y,m_picon); //loeschen

        m_value=newvalue;
        m_picon=pnewicon;
	draw();
}





