/*Copyright: Tim vor der Brck 1999

This software is released under the GNU General Public License.
It may be redistributed as long this copyright remark is not
removed or modified.
*/

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>



static Widget toplevel,messagebox,labelmsg,form,buttonmsg;
static XtAppContext appcontext;
static bool bfirsttime=true;
static void 
  onreturn(Widget w,XEvent *event,String* params,Cardinal* num);
static XtActionsRec actions[]={"onreturn",onreturn};
static char transTable[]="<Key>Return: onreturn()";



//************************* initMessageBox *************************
void initMessageBox(Widget top,XtAppContext appcon)
{
  toplevel=top;
  appcontext=appcon;
}

//********************** popdownMessageBox ********************
void popdownMessageBox(Widget w,XtPointer client,XtPointer call)
{
  XtPopdown(messagebox);
} 

//************************ onreturn *******************************
static void 
  onreturn(Widget w,XEvent *event,String* params,Cardinal* num)
{
  popdownMessageBox(w,NULL,NULL);
}

//**************************** interninitMessageBox *****************************
void interninitMessageBox()
{
  XtAppAddActions(appcontext,actions,XtNumber(actions));
  messagebox=XtVaCreatePopupShell("messagebox",
           transientShellWidgetClass,toplevel,
           XtNtranslations,XtParseTranslationTable(transTable),
           XtNinput,True,
	   NULL);
  form=XtVaCreateManagedWidget("formmsg",formWidgetClass,messagebox,NULL);
  labelmsg=XtVaCreateManagedWidget("labelmsg",labelWidgetClass,form,NULL);
  buttonmsg=XtVaCreateManagedWidget("OK",commandWidgetClass,
				    form,XtNfromVert,labelmsg,NULL);
  XtAddCallback(buttonmsg,XtNcallback,popdownMessageBox,NULL);
}


//******************** popupMessageBox *************************
/* message: output string
   realize: realises widget, should be set, if 
   MessageBox is poped up the first time after
   the command: Realize(toplevel) */
void popupMessageBox(const char* title,const char* message,bool realize=true)
{
  Position x,y;
  Dimension width,height;
  //first time, then initialize messagebox
  if (bfirsttime)  interninitMessageBox();
  XtVaGetValues(toplevel,XtNwidth,&width,XtNheight,&height,NULL);
  XtTranslateCoords(toplevel,(Position)width/2,(Position)height/2,&x,&y);
  XtVaSetValues(messagebox,XtNx,x,XtNy,y,XtNtitle,title,NULL);
  XtVaSetValues(labelmsg,XtNlabel,message,NULL);
  if (bfirsttime)
  {
    bfirsttime=false;
    if (realize) XtRealizeWidget(messagebox);
  }
  XtPopup(messagebox,XtGrabNonexclusive);
}

void createokcancelmsgbox(Widget top,Widget& ocpopup,Widget& ocform,Widget& oclabel,
                          Widget& ocok,Widget& occancel)
{
  ocpopup=XtVaCreatePopupShell("okcanceldlgpopup",transientShellWidgetClass,top,NULL);
  ocform=XtVaCreateManagedWidget("okcanceldlg",formWidgetClass,ocpopup,NULL);
  oclabel=XtVaCreateManagedWidget("oclabel",labelWidgetClass,ocform,NULL);
  ocok=XtVaCreateManagedWidget("ocok",commandWidgetClass,ocform,XtNfromVert,oclabel,NULL);
  occancel=XtVaCreateManagedWidget("occancel",commandWidgetClass,ocform,
           XtNfromHoriz,ocok,XtNfromVert,oclabel,NULL);
  XtRealizeWidget(ocpopup);
}
  

